<?php

define('_FIELDS_EXCEPTION__', " 'area_description', 'village_id' ");

// echo 'aaaaaa' ; exit();
function GetFieldDescription($strFieldName){
    if($strFieldName=='name'){
        return 'Nama' ;
    } elseif($strFieldName=='description'){
        return 'Deskripsi' ;
    } elseif($strFieldName=='code'){
        return 'Kode' ;
    } elseif($strFieldName=='sort_field'){
        return 'Urutan' ;
    } else {
        return $strFieldName ;
    }
}

function GetCountSystemJournaling($strSearch='', $blState = "A")
{
    $objDb = QApplication::$Database[1];
    $strSearch = pg_escape_string(strtoupper($strSearch));
    $strActivityId = System::GetValue('activity_id', '');
    $strTableName = System::GetValue('table_name', '');
    $strPrimaryKey = System::GetValue('primary_key', '');
    $strFieldName = System::GetValue('field_name', '');
    $dtStartDate = System::GetValue('start_date', null, 'date');
    if($dtStartDate){ $strStartDate = $dtStartDate->PhpDate('Y-m-d'); }
    $dtEndDate = System::GetValue('end_date', null, 'date');
    if($dtEndDate){ $strEndDate = $dtEndDate->PhpDate('Y-m-d'); }

    $WHERE = " WHERE system_journal_detail.state = '$blState' ";
    if($strSearch != "") {
       $WHERE = $WHERE . "
         AND
             (
                UPPER(system_journal_detail.field) LIKE '%$strSearch%'
                OR UPPER(system_journal_detail.new_value) LIKE '%$strSearch%'
                OR UPPER(system_journal_detail.old_value) LIKE '%$strSearch%'
             )
       ";
    }
    if(strlen($strActivityId)) {
       $WHERE = $WHERE . "
         AND system_journal_detail.system_activity_id = '$strActivityId'
       ";
    }
    if(strlen($strPrimaryKey)) {
        $WHERE = $WHERE . "
         AND system_journal_detail.primary_key = '$strPrimaryKey'
       ";
    }
    if(strlen($strTableName)==0) {
        $WHERE = $WHERE . "
         AND system_journal_detail.table_name IN ( 'system_department' , 'hmis_ref_department' )
       ";
    } else {
        $WHERE = $WHERE . "
         AND system_journal_detail.table_name IN ( '$strTableName' )
       ";
    }
    if($dtStartDate && $dtEndDate ){
       $WHERE = $WHERE . "
         AND ( system_journal_detail.create_time BETWEEN '$strStartDate 00:00:00' AND '$strEndDate 23:59:59' )
       ";
    }
    if(strlen($strFieldName)&&$strFieldName!='ALL') {
       $WHERE = $WHERE . "
         AND system_journal_detail.field = '$strFieldName'
       ";
    }
    $WHERE = $WHERE . "
         AND field NOT IN ("._FIELDS_EXCEPTION__.")
    ";

    $strSql = "
		 SELECT COUNT(system_journal_detail.id) AS jumlah
		 FROM system_journal_detail
		 $WHERE
	";
    // System::WriteLog('x-system-journal-count.txt',$strSql);
    $objDbResult = $objDb->Query($strSql);


    $strDbRow = $objDbResult->FetchRow();
    return $strDbRow[0];
}

function GetRecordSystemJournaling($intStart, $intLimit, $strSearch='', $blState = "A", $strSortField = 'id', $strSortTipe = 'ASC')
{

    $objDb = QApplication::$Database[1];
    $strSearch = pg_escape_string(strtoupper($strSearch));
    $strActivityId = System::GetValue('activity_id', '');
    $strTableName = System::GetValue('table_name', '');
    $strPrimaryKey = System::GetValue('primary_key', '');
    $strFieldName = System::GetValue('field_name', '');
    $dtStartDate = System::GetValue('start_date', null, 'date');
    if($dtStartDate){ $strStartDate = $dtStartDate->PhpDate('Y-m-d'); }
    $dtEndDate = System::GetValue('end_date', null, 'date');
    if($dtEndDate){ $strEndDate = $dtEndDate->PhpDate('Y-m-d'); }

    $WHERE = " WHERE system_journal_detail.state = '$blState' ";
    if($strSearch != "") {
       $WHERE = $WHERE . "
         AND
             (
                UPPER(system_journal_detail.field) LIKE '%$strSearch%'
                OR UPPER(system_journal_detail.new_value) LIKE '%$strSearch%'
                OR UPPER(system_journal_detail.old_value) LIKE '%$strSearch%'
             )
       ";
    }
    if(strlen($strActivityId)) {
       $WHERE = $WHERE . "
         AND system_journal_detail.system_activity_id = '$strActivityId'
       ";
    }
    if(strlen($strTableName)==0) {
       $WHERE = $WHERE . "
         AND system_journal_detail.table_name IN ( 'system_department' , 'hmis_ref_department' )
       ";
    } else {
        $WHERE = $WHERE . "
         AND system_journal_detail.table_name IN ( '$strTableName' )
       ";
    }

    if(strlen($strPrimaryKey)) {
       $WHERE = $WHERE . "
         AND system_journal_detail.primary_key = '$strPrimaryKey'
       ";
    }
    if($dtStartDate && $dtEndDate){
       $WHERE = $WHERE . "
         AND system_journal_detail.system_activity_id = system_activity.id
         AND ( system_journal_detail.create_time BETWEEN '$strStartDate 00:00:00' AND '$strEndDate 23:59:59' )
         AND ( system_activity.create_time BETWEEN '$strStartDate 00:00:00' AND '$strEndDate 23:59:59' )
       ";
    }
    if(strlen($strFieldName)&&$strFieldName!='ALL') {
       $WHERE = $WHERE . "
         AND system_journal_detail.field = '$strFieldName'
       ";
    }
    $WHERE = $WHERE . "
         AND field NOT IN ("._FIELDS_EXCEPTION__.")
    ";

    $SORT = '';
    if (isset($strSortTipe) && isset($strSortField)) {
        if ($strSortField == 'Id') {
            $SORT = "ORDER BY system_journal_detail.id $strSortTipe";
        } else if ($strSortField == 'Description') {
            $SORT = "ORDER BY system_journal_detail.new_value $strSortTipe";
        } else if ($strSortField == 'Code') {
            $SORT = "ORDER BY system_journal_detail.old_value $strSortTipe";
        } else if ($strSortField == 'SortField') {
            $SORT = "ORDER BY system_journal_detail.create_time $strSortTipe";
        }
    }
    // if($SORT==''){
        $SORT = "ORDER BY system_journal_detail.create_time DESC , system_journal_detail.seq ASC";
    // }

    $strSql = "
		SELECT system_activity.action_code ,system_journal_detail.* , system_user.full_name , system_user.login_name
		FROM system_journal_detail AS system_journal_detail LEFT JOIN system_user AS system_user ON ( system_journal_detail.create_user = system_user.id )
			 , system_activity AS system_activity
		$WHERE
		ORDER BY system_journal_detail.seq ASC , system_journal_detail.id ASC
		LIMIT $intLimit OFFSET $intStart
	";

    // System::WriteLog('x-system-journal-detail-data.txt',$strSql);
    $objDbResult = $objDb->Query($strSql);

    if ($objDbResult->CountRows() > 0) {
        $u = array();
        $i = 0;
        while ($row = $objDbResult->FetchArray()) {
            $u[$i]['Id'] = $row['id'];
            if($row['login_name']){
                $strFullname = $row['full_name'];
                $strLoginName = $row['login_name'];
                $strPrefixNotes = 'oleh ';
                $strNotes = '';
            } else {
                $strFullname = 'Tak diketahui';
                $strLoginName = 'unknown';
                $strPrefixNotes = '';
                $strNotes = ' * telah dihapus manual';
            }
            if($row['action_code']=='INSERT'){
                $u[$i]['*'] =
                    ' ## Input Data Tgl ' . $row['create_time'] .
                    ' ## ' . $strPrefixNotes . $strFullname . ' [' . $strLoginName  . ']' . $strNotes .
                    ' ## dari ' . $row['ip_address'] . ' ##' ;
            } else {
                $u[$i]['*'] =
                    ' ## Update Data Tgl ' . $row['create_time'] .
                    ' ## ' . $strPrefixNotes . $strFullname . ' [' . $strLoginName . ']' . $strNotes .
                    ' ## dari ' . $row['ip_address'] . ' ##' ;
            }
            $u[$i]['FieldName'] = $row['field'];
            $u[$i]['FieldDescription'] = GetFieldDescription($row['field']);
            $u[$i]['Seq'] = $row['seq'];
            $u[$i]['NewValue'] = $row['new_value'];
            $u[$i]['OldValue'] = $row['old_value'];
            $u[$i]['CreateTime'] = $row['create_time'];
            $u[$i]['IpAddress'] = $row['ip_address'];
            $i++;
        }
        return $u;
    }	else {
        return 0;
    }
}

// ============================================================================================= //
// Main	Service																					 //
// ============================================================================================= //

function service()
{
    $strState = System::GetValue('state','');
    $strOption = System::GetValue('option','');
    if( $strState ) {
        if($strState == 'validate' || $strState == 'submit')
        {
            $Id	= System::GetValue('Id','');
            $Name = System::GetValue('Name','');
            $Description = System::GetValue('Description','');
            $Code = System::GetValue('Code','');
            $SortField = System::GetValue('SortField','');
        }
        if($strState == 'validate')
        {
            /*
            $objSystemApplication = SystemApplication::LoadByCode($Code);
            if($Id){
                // Validasi Kode untuk data lama
                if($objSystemApplication && $objSystemApplication->Id!=$Id)
                    return System::Result(
                        false
                        , 'Code'
                        , '"Code" sudah dipergunakan, Isi dengan "Code" lain'
                    );
            } else {
                // Validasi Kode untuk data baru
                if($objSystemApplication)
                    return System::Result(
                        false
                        , 'Code'
                        , '"Code" sudah dipergunakan, Isi dengan "Code" lain'
                    );
            }
            */
            return System::Result(true, '', '');
        }
        else if($strState == 'submit')
        {
            // kembalikan sukses //
            return System::Result(true, 'Id', '');
        }
        else if($strState == 'delete')
        {
            // kembalikan sukses //
            return System::Result(false, '', '');
        }
        else if($strState == 'request_data')
        {
            if(isset($_POST['start']) || isset($_GET['start']) ){
                $intStart = System::GetValue('start', 0);
                $intLimit = System::GetValue('limit', 20);
                $strSearch = System::GetValue('search', '');
                $blState = System::GetValue('blState', 'A');
                $strSortField = System::GetValue('sort', '');
                $sort_dir = System::GetValue('dir', 'ASC');
                if( $strSortField && $sort_dir ) {
                    $dataset = GetRecordSystemJournaling($intStart, $intLimit, $strSearch, $blState, $strSortField, $sort_dir);
                } else {
                    $dataset = GetRecordSystemJournaling($intStart, $intLimit, $strSearch, $blState);
                }
                $count = GetCountSystemJournaling($strSearch, $blState);
                // $str_dataset = var_export($dataset, true);
                return System::ResultRecordset($dataset, $count);
            }
        }
        return null;
    }
    return null;
}

// ============================================================================================= //

// System::WriteLog('x-test-point-0.txt','');

// ============================================================================================= //

echo service();

// ============================================================================================= //

?>
